//
//  DiaryStore.m
//  MyDiary
//
//  Created by Apple on 13-11-18.
//  Copyright (c) 2013年 apple. All rights reserved.
//

#import "DiaryStore.h"
static DiaryStore *defaultStore = nil ;
@implementation DiaryStore
+(DiaryStore *)defaultStore
{
    if(!defaultStore)
    {
        defaultStore = [[super allocWithZone:NULL] init];
    }
    return defaultStore ;
}

+(id)allocWithZone:(NSZone *)zone
{
    return [self defaultStore] ;
}

-(id)init
{
    
    if(defaultStore)
    {
        return defaultStore ;
    }
    self = [super init];
//    if(self)
//    {
//        diaries = [[NSMutableArray alloc] init];
//    }
    return self ;
}

-(NSArray *)diaries
{
    [self fetchDiary];
    return diaries;
}

-(Diary *)createDiary
{
    [self fetchDiary];
    Diary *diary = [Diary createDiary];
    [diaries addObject:diary];
    return diary ;
}
-(NSString *)diaryArchivePath
{
    //获取沙箱中Document目录的路径
    NSArray *doc = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    //从NSArray中获取路径
    NSString *docDirectory = [doc objectAtIndex:0];
    //在路径后添加文件名称后返回
    return [docDirectory stringByAppendingPathComponent:@"diaries.data"];
    
}

-(BOOL)saveChange
{
    return [NSKeyedArchiver archiveRootObject:diaries toFile:[self diaryArchivePath]];
}

- (void)fetchDiary
{
    if(!diaries)
    {
        NSString *path = [self diaryArchivePath];
        diaries = [NSKeyedUnarchiver unarchiveObjectWithFile:path];
    }
    if(!diaries)
    {
        diaries = [[NSMutableArray alloc]init];
    }
}
@end






