//
//  ImageStore.m
//  MyDiary
//
//  Created by kgy on 13-11-6.
//  Copyright (c) 2013年 apple. All rights reserved.
//

#import "ImageStore.h"

static ImageStore *defaultImageStore = nil;

@implementation ImageStore

//防止创建另一个该类型的实例
+(id)allocWithZone:(NSZone *)zone
{
    return [self defaultImageStore];
}

+(ImageStore *)defaultImageStore
{
    if(!defaultImageStore){
        defaultImageStore = [[super allocWithZone:NULL]init];
    }
    return defaultImageStore;
}

-(id)init
{
    if(defaultImageStore){
        return  defaultImageStore;
    }
    
    self = [super init];
    if(self){
        dictionary = [[NSMutableDictionary alloc]init];
    }
    
    return self;
}

-(void)setImage:(UIImage *)image forKey:(NSString *)string
{
    NSString *imagePath = [self pathInDocumentDirectory:string];
    NSData *d = UIImageJPEGRepresentation(image, 0.5);
    [d writeToFile:imagePath atomically:YES];
    [dictionary setObject:image forKey:string];
}

-(UIImage *)imageForKey:(NSString *)string
{
    UIImage *image = [dictionary objectForKey:string];
    if(!image)
    {
        image = [UIImage imageWithContentsOfFile:[self pathInDocumentDirectory:string]];
        if(image)
        {
            [dictionary setObject:image forKey:string];
        }
    
    }
    return [dictionary objectForKey:string];
}

-(void)deleteImageforKey:(NSString *)string
{
    if(!string){
        return;
    }
    NSString *path = [self pathInDocumentDirectory:string];
    [[NSFileManager defaultManager] removeItemAtPath:path error:NULL];
    
    [dictionary removeObjectForKey:string];
}
//获取图片路径
- (NSString *)pathInDocumentDirectory:(NSString *)fileName
{
    NSArray *doc = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    NSString *docementDirectory = [doc objectAtIndex:0];
    return [docementDirectory stringByAppendingPathComponent:fileName];
}
@end
